
/*
  +------------------------------------------------------------------------+
  | Phalcon Framework                                                      |
  +------------------------------------------------------------------------+
  | Copyright (c) 2011-2013 Phalcon Team (http://www.phalconphp.com)       |
  +------------------------------------------------------------------------+
  | This source file is subject to the New BSD License that is bundled     |
  | with this package in the file docs/LICENSE.txt.                        |
  |                                                                        |
  | If you did not receive a copy of the license and are unable to         |
  | obtain it through the world-wide-web, please send an email             |
  | to license@phalconphp.com so we can send you a copy immediately.       |
  +------------------------------------------------------------------------+
  | Authors: Andres Gutierrez <andres@phalconphp.com>                      |
  |          Eduar Carvajal <eduar@phalconphp.com>                         |
  |          ZhuZongXin <dreamsxin@qq.com>                                 |
  +------------------------------------------------------------------------+
*/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "php.h"
#include "php_phalcon.h"
#include "phalcon.h"

#include <Zend/zend_operators.h>
#include <Zend/zend_exceptions.h>
#include <Zend/zend_interfaces.h>

#include "kernel/main.h"
#include "kernel/memory.h"

/**
 * Phalcon\Http\Client\Exception
 *
 * Exceptions thrown in Phalcon\Http\Client will use this class
 *
 */
 zend_class_entry *phalcon_http_client_exception_ce;


/**
 * Phalcon\Http\Client\Exception initializer
 */
PHALCON_INIT_CLASS(Phalcon_Http_Client_Exception){

	PHALCON_REGISTER_CLASS_EX(Phalcon\\Http\\Client, Exception, http_client_exception, phalcon_exception_ce, NULL, 0);

	return SUCCESS;
}

